cfetApp.CFETModule.controller('SettingsController',
    function ($scope, $modal, cfService, $location, $q) {
        $scope.doReset = function () {
            var resetModal = $modal.open({
                templateUrl: 'app/template/resetDialog.html',
                size: 'sm',
                scope: $scope,
                backdrop: false
            });


            resetModal.result.then(function () {

                // TODO: open spinner mask


                cancelInProgressTasks()['finally'](deleteData).then(success, fail);

                function cancelInProgressTasks() {
                    return cfService.getVideoDownloader().cancelDownloads();
                }

                function deleteData() {
                    cfService.setUser(null);
                    cfClient.setCredentials(null, null);
                    return cfService.deleteAllData();

                }

                function goToLogin() {
                    $location.path('/logincheck');
                }

                function success() {
                    // TODO: close spinner mask
                    $scope.msgHeaderKey = 'reset';
                    $scope.msgBodyKey = 'reset_completed_message';
                    var resultModal = $modal.open({
                        templateUrl: 'app/template/alertDialog.html',
                        size: 'sm',
                        scope: $scope,
                        backdrop: false
                    });

                    resultModal.result.then(goToLogin, goToLogin);
                }


                function fail() {
                    // error message
                    // TODO: close spinner mask
                    $scope.msgHeaderKey = 'reset';
                    $scope.msgBodyKey = 'reset_error_message';

                    var resultModal = $modal.open({
                        templateUrl: 'app/template/alertDialog.html',
                        size: 'sm',
                        scope: $scope,
                        backdrop: false
                    });

                    resultModal.result.then(goToLogin, goToLogin);
                }
            });
        };

        $scope.doUber = function () {
            var resetModal = $modal.open({
                templateUrl: 'app/template/uberDialog.html',
                size: 'sm',
                scope: $scope,
                backdrop: true
            });

        };
    }
);