cfetApp.CFETModule.controller('StartseiteController',
    function ($scope, $modal, $cordovaBarcodeScanner, cfService, $location) {
        // fix rotation sizes
        var w = window.innerWidth;
        var h = window.innerHeight;

        //$scope.maxWidth = w;

        //$('.maxHeight').height(h);
        //$('.maxWidth').width(w);

        //app.onResize('startseitecontroller');

        jQuery('body').css({'background-color': 'white'});

        var cfUser = cfService.getUser();


        $scope.doScanQRCode = function () {

            if(cfService.isOffline()) {
                $scope.showOfflineMessage('scanned_card_can_only_be_opened_with_connection');
                return;
            }

            $cordovaBarcodeScanner.scan().then(function (imageData) {

                console.log("scan ok", arguments);
                if(imageData.cancelled) {
                    return;
                }

                var link = imageData.text;

                if(!cfService.isValidScanLink(link)) {
                    console.log("invalid link " + link);
                    $scope.msgHeaderKey = 'fehler';
                    $scope.msgBodyKey = 'error_msg_invalid_link';
                    $modal.open({
                        templateUrl: 'app/template/alertDialog.html',
                        size: 'sm',
                        scope: $scope,
                        backdrop: true
                    });

                    return;
                }

                // link ok open external browser
                cfService.openWebsiteUrlWithAuthentication(link);
            }, function (err) {
                console.log("error", arguments);
                $scope.msgHeaderKey = 'fehler';
                $scope.msgBodyKey = 'error_msg_scannen';
                $modal.open({
                    templateUrl: 'app/template/alertDialog.html',
                    size: 'sm',
                    scope: $scope,
                    backdrop: true
                });
            });
        };







    }
);